﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.IO.Ports;  //追加 シリアルポートコンポーネント用
using static System.Windows.Forms.VisualStyles.VisualStyleElement;

namespace _011_PC_PIC_UART_S_JIS_Nobunaga
{
    public partial class Form1 : Form
    {

        //文字を変換するクラスを宣言
        Encoding encSjis = Encoding.GetEncoding("shift-jis");
        Encoding encUni = Encoding.GetEncoding("unicode");

        delegate void ReceiveDelegate(string str);//デリゲート宣言
        public Form1()
        {
            InitializeComponent();
            SendDataCBox.Items.Clear();

            SendDataCBox.Items.Add("織田");
            SendDataCBox.Items.Add("豊臣");
            SendDataCBox.Items.Add("徳川");
            SendDataCBox.Items.Add("Oda");
            SendDataCBox.Items.Add("Toyotomi");
            SendDataCBox.Items.Add("Tokugawa");

            SendDataCBox.Items.Add("How are you ?");
            SendDataCBox.Items.Add("ご機嫌いかがですか？");

            SendDataCBox.SelectedIndex = 0;


            string[] PortList = SerialPort.GetPortNames();

            try
            {

                ComCBox.Items.Clear();

                //シリアルポート名をコンボボックスにセット
                foreach (string PortName in PortList)
                {
                    ComCBox.Items.Add(PortName);
                }
                if (ComCBox.Items.Count > 0)
                {
                    ComCBox.SelectedIndex = 0;
                }

                serialPort1.PortName = ComCBox.SelectedItem.ToString();

                //   serialPort1.PortName = "COM3";  //COM1 ﾎﾟｰﾄ使用
                //   serialPort1.PortName = "COM4";  //COM1 ﾎﾟｰﾄ使用
                serialPort1.BaudRate = 115200;   //9600bps
                //serialPort1.BaudRate = 9600;   //9600bps
                serialPort1.Parity = System.IO.Ports.Parity.None;  //パリティなし
                serialPort1.DataBits = 8;  //データ長　8ビット
                serialPort1.StopBits = System.IO.Ports.StopBits.One;   //ストップビット 1
                serialPort1.ReadTimeout = 500;     //500mse 読み込みタイムアウト時間
                serialPort1.WriteTimeout = 500;    //500msec書き込みタイムアウト時間

                serialPort1.Open();//シリアルポートオープン

            }
            catch (Exception ex)
            {
                DialogResult result = MessageBox.Show
                (ex.Message + "\n" + "COMポートがひらけません。COMポートを接続してから本アプリケーションを起動してください。");
            }

        }

        private void SendBtn_Click(object sender, EventArgs e)
        {
            serialPort1.DiscardInBuffer();  //受信バッファのデータクリア
        //    serialPort1.DiscardOutBuffer();  //送信バッファのデータクリア

            string strSend = SendDataCBox.Text;
            if (!strSend.EndsWith("\r")) strSend += "\r";  //改行が無かったら \rを追加する
            Byte[] byteArry = encSjis.GetBytes(strSend); //'送信文字をShift-jisに変換してをByte配列に格納
            serialPort1.Write(byteArry, 0, byteArry.Length); //送信

        }

        private void ClearBtn_Click(object sender, EventArgs e)
        {
            
            richTextBox1.Clear();
        }

    

        private void SetText(string str)
        {
            richTextBox1.Focus();   //最終行にフォーカスをセット 
            richTextBox1.AppendText(str);   //文字列追加
        }

        private void serialPort1_DataReceived(object sender, SerialDataReceivedEventArgs e)
        {

            byte[] byteRead = new byte[serialPort1.BytesToRead];  //受信文字

            serialPort1.Read(byteRead, 0, serialPort1.BytesToRead);//読み込み
            byte[] byteUni = Encoding.Convert(encSjis, encUni, byteRead);   //shift-jis　からunicodeに変換する
            string strUni = encUni.GetString(byteUni);  //配列を文字列に変換
            ReceiveDelegate receiveDelegate = new ReceiveDelegate(SetText);
            this.Invoke(receiveDelegate, strUni);
        }

        private void ComCBox_TextChanged(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen == true)
            {
                serialPort1.Close();//シリアルポートクローズ

                serialPort1.PortName = ComCBox.SelectedItem.ToString();
                serialPort1.BaudRate = 115200;   //115200bps
                //serialPort1.BaudRate = 9600;   //9600bps
                serialPort1.Parity = System.IO.Ports.Parity.None;  //パリティなし
                serialPort1.DataBits = 8;  //データ長　8ビット
                serialPort1.StopBits = System.IO.Ports.StopBits.One;   //ストップビット 1
                serialPort1.ReadTimeout = 500;     //500mse 読み込みタイムアウト時間
                serialPort1.WriteTimeout = 500;    //500msec書き込みタイムアウト時間

                serialPort1.Open();//シリアルポートオープン

            }

        }
    }
}
